import modularEventKeeper
event = modularEventKeeper.EventKeeper()
spell = modularEventKeeper.CumulatingDict()
randomEvent = modularEventKeeper.CumulatingDict()

# module code

import CvPythonExtensions
gc = CvPythonExtensions.CyGlobalContext()

# Add new functionality:
@event.BuildingTypeBuilt('BUILDING_CATACOMB_LIBRALUS')
def catacombLibralusAdepts( data ):
    iBuildingClass = data['iBuildingClass']
    pPlot = data['pPlot']
    game = data['game']
    pPlayer = data['pPlayer']
    pCity = data['pCity']
    iBuildingType = data['iBuildingType']

    iAdept = gc.getInfoTypeForString('UNIT_ADEPT')
    iChanneling2 = gc.getInfoTypeForString('PROMOTION_CHANNELING2')
    spawnX = pCity.getX()
    spawnY = pCity.getY()
    initArgs = ( iAdept, spawnX, spawnY, CvPythonExtensions.UnitAITypes.NO_UNITAI, CvPythonExtensions.DirectionTypes.DIRECTION_NORTH )
    for name in [ 'Onestone', 'Ielilag' ]:
        newUnit = pPlayer.initUnit( *initArgs )
        newUnit.setHasPromotion( iChanneling2, True)
        newUnit.setName(name)
        newUnit.setLevel(2)

# Remove old functionality
# I hate these popups
event.GameStart( name='showDawnOfMan' )( None )
event.GameStart( name='introMovie' )( None )
event.EndPlayerTurn( name='doBeginningCivicChangeSuggestion' )( None )

# Change old functionality
# The () is not optional
@event.UnitBuilt()
def drunkenDwarves( data ):
    unit = data['pUnit']
    if unit.isHasPromotion( gc.getInfoTypeForString('PROMOTION_DWARF') ):
        bonusXP = data['pCity'].getNumBonuses( gc.getInfoTypeForString('BONUS_ALE') )
        unit.changeExperience( bonusXP, -1, False, False, False )

# Mark this function to be included in CvSpellInterface
@spell
def reqDrainSoul( pCaster ):
    return pCaster.getExperienceTimes100() >= 100

# () is allowed here, but not nessecary.
# I discourage it, but decided to allow it for consistency.
@spell()
def spellDrainSoul( pCaster ):
    iX = pCaster.getX()
    iY = pCaster.getY()
    pPlot = CvPythonExtensions.CyMap().plot(iX, iY)
    pCity = pPlot.getPlotCity()
    soulStrength = pCaster.getExperienceTimes100()
    pCity.changeProduction( soulStrength/100 )
    CvPythonExtensions.CyInterface().addMessage(pCity.getOwner(),True,25,CvPythonExtensions.CyTranslator().getText("TXT_KEY_MESSAGE_SOUL_FORGE",()),'AS2D_DISCOVERBONUS',1,'Art/Interface/Buttons/Buildings/Soulforge.dds',CvPythonExtensions.ColorTypes(7), iX, iY, True, True )
    pCaster.changeExperience( int(-soulStrength/100), -1, False, False, False )

@spell
def getHelpDrainSoul( args ):
    eSpell, pCaster = args
    soulStrength = pCaster.getExperienceTimes100()
    return 'Adds %i to the citys production' % int( soulStrength/100 )

